Eventscripts: print a message when reconfiguring a service.
[sahlberg/ctdb.git] / config / functions
old mode 100644 (file)
new mode 100755 (executable)
index 87026ac..8dac161
@@ -4,19 +4,18 @@ PATH=/bin:/usr/bin:/usr/sbin:/sbin:$PATH
 
 #######################################
 # pull in a system config file, if any
-loadconfig() {
-
-    if [ "$1" != "ctdb" ] ; then
-       loadconfig "ctdb"
-    fi
+_loadconfig() {
 
     if [ -z "$1" ] ; then
        foo="${service_config:-${service_name}}"
        if [ -n "$foo" ] ; then
            loadconfig "$foo"
        fi
+    elif [ "$1" != "ctdb" ] ; then
+       loadconfig "ctdb"
     fi
 
+
     if [ -f /etc/sysconfig/$1 ]; then
        . /etc/sysconfig/$1
     elif [ -f /etc/default/$1 ]; then
@@ -26,6 +25,10 @@ loadconfig() {
     fi
 }
 
+loadconfig () {
+    _loadconfig "$@"
+}
+
 ##############################################################
 # determine on what type of system (init style) we are running
 detect_init_style() {
@@ -62,10 +65,19 @@ service() {
 ######################################################
 # simulate /sbin/service (niced) on platforms that don't have it
 nice_service() { 
+  _service_name="$1"
+  _op="$2"
+
   # do nothing, when no service was specified
-  [ -z "$1" ] && return
+  [ -z "$_service_name" ] && return
 
-    nice service "$@"
+  if [ -x /sbin/service ]; then
+      nice /sbin/service "$_service_name" "$_op"
+  elif [ -x /etc/init.d/$_service_name ]; then
+      nice /etc/init.d/$_service_name "$_op"
+  elif [ -x /etc/rc.d/init.d/$_service_name ]; then
+      nice /etc/rc.d/init.d/$_service_name "$_op"
+  fi
 }
 
 ######################################################
@@ -136,10 +148,14 @@ ctdb_check_rpc() {
     progname="$1"
     prognum="$2"
     version="$3"
-    rpcinfo -u localhost $prognum $version > /dev/null || {
-           echo "ERROR: $progname not responding to rpc requests"
-           exit 1
-    }
+
+    ctdb_check_rpc_out=$(rpcinfo -u localhost $prognum $version 2>&1)
+    if [ $? -ne 0 ] ; then
+       ctdb_check_rpc_out="ERROR: $progname failed RPC check:
+$ctdb_check_rpc_out"
+       echo "$ctdb_check_rpc_out"
+       return 1
+    fi
 }
 
 ######################################################
@@ -154,7 +170,7 @@ ctdb_check_directories_probe() {
                continue
                ;;
            *)
-               [ -d "$d" ] || return 1
+               [ -d "${d}/." ] || return 1
        esac
     done
 }
@@ -223,7 +239,7 @@ kill_tcp_connections() {
     _failed=0
 
     _killcount=0
-    connfile="$CTDB_BASE/state/connections.$_IP"
+    connfile="$CTDB_VARDIR/state/connections.$_IP"
     netstat -tn |egrep "^tcp.*[[:space:]]+$_IP:.*ESTABLISHED" | awk '{print $4" "$5}' > $connfile
     netstat -tn |egrep "^tcp.*[[:space:]]+::ffff:$_IP:.*ESTABLISHED" | awk '{print $4" "$5}' >> $connfile
 
@@ -273,7 +289,7 @@ kill_tcp_connections_local_only() {
     _failed=0
 
     _killcount=0
-    connfile="$CTDB_BASE/state/connections.$_IP"
+    connfile="$CTDB_VARDIR/state/connections.$_IP"
     netstat -tn |egrep "^tcp.*[[:space:]]+$_IP:.*ESTABLISHED" | awk '{print $4" "$5}' > $connfile
     netstat -tn |egrep "^tcp.*[[:space:]]+::ffff:$_IP:.*ESTABLISHED" | awk '{print $4" "$5}' >> $connfile
 
@@ -307,6 +323,36 @@ kill_tcp_connections_local_only() {
     echo "killed $_killcount TCP connections to released IP $_IP"
 }
 
+##################################################################
+# tickle any TCP connections with the given IP
+##################################################################
+tickle_tcp_connections() {
+    _IP="$1"
+    _failed=0
+
+    _killcount=0
+    connfile="$CTDB_VARDIR/state/connections.$_IP"
+    netstat -tn |egrep "^tcp.*[[:space:]]+$_IP:.*ESTABLISHED" | awk '{print $4" "$5}' > $connfile
+    netstat -tn |egrep "^tcp.*[[:space:]]+::ffff:$_IP:.*ESTABLISHED" | awk '{print $4" "$5}' >> $connfile
+
+    while read dest src; do
+       srcip=`echo $src | sed -e "s/:[^:]*$//"`
+       srcport=`echo $src | sed -e "s/^.*://"`
+       destip=`echo $dest | sed -e "s/:[^:]*$//"`
+       destport=`echo $dest | sed -e "s/^.*://"`
+       echo "Tickle TCP connection $srcip:$srcport $destip:$destport"
+       ctdb tickle $srcip:$srcport $destip:$destport >/dev/null 2>&1 || _failed=1
+       echo "Tickle TCP connection $destip:$destport $srcip:$srcport"
+       ctdb tickle $destip:$destport $srcip:$srcport >/dev/null 2>&1 || _failed=1
+     done < $connfile
+    /bin/rm -f $connfile
+
+    [ $_failed = 0 ] || {
+       echo "Failed to send tickle control"
+       return;
+    }
+}
+
 ########################################################
 # start/stop the nfs service on different platforms
 ########################################################
@@ -328,6 +374,12 @@ startstop_nfs() {
                stop)
                        service nfsserver stop > /dev/null 2>&1
                        ;;
+               restart)
+                       echo 0 >/proc/fs/nfsd/threads
+                       service nfsserver stop > /dev/null 2>&1
+                       pkill -9 nfsd
+                       service nfsserver start
+                       ;;
                esac
                ;;
        rhel)
@@ -340,6 +392,14 @@ startstop_nfs() {
                        service nfs stop > /dev/null 2>&1
                        service nfslock stop > /dev/null 2>&1
                        ;;
+               restart)
+                       echo 0 >/proc/fs/nfsd/threads
+                       service nfs stop > /dev/null 2>&1
+                       service nfslock stop > /dev/null 2>&1
+                       pkill -9 nfsd
+                       service nfslock start
+                       service nfs start
+                       ;;
                esac
                ;;
        *)
@@ -372,6 +432,10 @@ startstop_nfslock() {
                stop)
                        service nfsserver stop > /dev/null 2>&1
                        ;;
+               restart)
+                       service nfsserver stop
+                       service nfsserver start
+                       ;;
                esac
                ;;
        rhel)
@@ -382,6 +446,10 @@ startstop_nfslock() {
                stop)
                        service nfslock stop > /dev/null 2>&1
                        ;;
+               restart)
+                       service nfslock stop
+                       service nfslock start
+                       ;;
                esac
                ;;
        *)
@@ -391,28 +459,86 @@ startstop_nfslock() {
        esac
 }
 
-########################################################
-# remove an ip address from an interface
-########################################################
+# better use delete_ip_from_iface() together with add_ip_to_iface
+# remove_ip should be removed in future
 remove_ip() {
-       # the ip tool will delete all secondary IPs if this is the primary.
-       # To work around this _very_ annoying behaviour we have to keep a
-       # record of the secondaries and re-add them afterwards. yuck
-       secondaries=""
-       if ip addr list dev $2 primary | grep -q "inet $1 " ; then
-           secondaries=`ip addr list dev $2 secondary | grep " inet " | awk '{print $2}'`
-       fi
-       ip addr del $1 dev $2 >/dev/null 2>/dev/null || failed=1
-       [ -z "$secondaries" ] || {
-           for i in $secondaries; do
-               if ip addr list dev $2 | grep -q "inet $i" ; then
-                   echo "kept secondary $i on dev $2"
-               else 
-                   echo "re-adding secondary address $i to dev $2"
-                   ip addr add $i dev $2 || failed=1           
-               fi
-           done
+       local _ip_maskbits=$1
+       local _iface=$2
+       local _ip=`echo "$_ip_maskbits" | cut -d '/' -f1`
+       local _maskbits=`echo "$_ip_maskbits" | cut -d '/' -f2`
+
+       delete_ip_from_iface "$_iface" "$_ip" "$_maskbits"
+       return $?
+}
+
+add_ip_to_iface()
+{
+       local _iface=$1
+       local _ip=$2
+       local _maskbits=$3
+       local _state_dir="$CTDB_VARDIR/state/interface_modify"
+       local _lockfile="$_state_dir/$_iface.flock"
+       local _readd_base="$_state_dir/$_iface.readd.d"
+
+       mkdir -p $_state_dir || {
+               ret=$?
+               echo "Failed to mkdir -p $_state_dir - $ret"
+               return $ret
        }
+
+       test -f $_lockfile || {
+               touch $_lockfile
+       }
+
+       flock --timeout 30 $_lockfile $CTDB_BASE/interface_modify.sh add "$_iface" "$_ip" "$_maskbits" "$_readd_base"
+       return $?
+}
+
+delete_ip_from_iface()
+{
+       local _iface=$1
+       local _ip=$2
+       local _maskbits=$3
+       local _state_dir="$CTDB_VARDIR/state/interface_modify"
+       local _lockfile="$_state_dir/$_iface.flock"
+       local _readd_base="$_state_dir/$_iface.readd.d"
+
+       mkdir -p $_state_dir || {
+               ret=$?
+               echo "Failed to mkdir -p $_state_dir - $ret"
+               return $ret
+       }
+
+       test -f $_lockfile || {
+               touch $_lockfile
+       }
+
+       flock --timeout 30 $_lockfile $CTDB_BASE/interface_modify.sh delete "$_iface" "$_ip" "$_maskbits" "$_readd_base"
+       return $?
+}
+
+setup_iface_ip_readd_script()
+{
+       local _iface=$1
+       local _ip=$2
+       local _maskbits=$3
+       local _readd_script=$4
+       local _state_dir="$CTDB_VARDIR/state/interface_modify"
+       local _lockfile="$_state_dir/$_iface.flock"
+       local _readd_base="$_state_dir/$_iface.readd.d"
+
+       mkdir -p $_state_dir || {
+               ret=$?
+               echo "Failed to mkdir -p $_state_dir - $ret"
+               return $ret
+       }
+
+       test -f $_lockfile || {
+               touch $_lockfile
+       }
+
+       flock --timeout 30 $_lockfile $CTDB_BASE/interface_modify.sh readd_script "$_iface" "$_ip" "$_maskbits" "$_readd_base" "$_readd_script"
+       return $?
 }
 
 ########################################################
@@ -452,6 +578,19 @@ ctdb_check_counter_limit () {
        echo "WARNING: less than $_limit consecutive failures ($_size) for $service_name, not unhealthy yet"
     fi
 }
+ctdb_check_counter_equal () {
+    _ctdb_counter_common
+
+    _limit=$1
+
+    # unary counting!
+    _size=$(stat -c "%s" "$_counter_file" 2>/dev/null || echo 0)
+    if [ $_size -eq $_limit ] ; then
+       return 1
+    fi
+    return 0
+}
+
 ########################################################
 
 ctdb_spool_dir="/var/spool/ctdb"
@@ -461,7 +600,7 @@ ctdb_active_dir="$ctdb_spool_dir/active"
 
 log_status_cat ()
 {
-    echo "node is \"$1\", problem with \"${script_name}\": $(cat $2)"
+    echo "node is \"$1\", \"${script_name}\" reports problem: $(cat $2)"
 }
 
 ctdb_checkstatus ()
@@ -512,6 +651,7 @@ ctdb_service_unset_reconfigure ()
 
 ctdb_service_reconfigure ()
 {
+    echo "Reconfiguring service \"$service_name\"..."
     if [ -n "$service_reconfigure" ] ; then
        eval $service_reconfigure
     else
@@ -530,49 +670,53 @@ ctdb_compat_managed_service ()
 
 is_ctdb_managed_service ()
 {
+    _service_name="${1:-${service_name}}"
+
     t=" $CTDB_MANAGED_SERVICES "
 
     ctdb_compat_managed_service "$CTDB_MANAGES_VSFTPD"   "vsftpd"
     ctdb_compat_managed_service "$CTDB_MANAGES_SAMBA"    "samba"
     ctdb_compat_managed_service "$CTDB_MANAGES_SCP"      "scp"
-    ctdb_compat_managed_service "$CTDB_MANAGES_WINDBIND" "windbind"
+    ctdb_compat_managed_service "$CTDB_MANAGES_WINBIND"  "winbind"
     ctdb_compat_managed_service "$CTDB_MANAGES_HTTPD"    "httpd"
     ctdb_compat_managed_service "$CTDB_MANAGES_ISCSI"    "iscsi"
     ctdb_compat_managed_service "$CTDB_MANAGES_CLAMD"    "clamd"
     ctdb_compat_managed_service "$CTDB_MANAGES_NFS"      "nfs"
+    ctdb_compat_managed_service "$CTDB_MANAGES_NFS"      "nfs-ganesha-gpfs"
 
-    # Returns 0 if "<space>$service_name<space>" appears in $t
-    [ "${t#* ${service_name} }" != "${t}" ]
+    # Returns 0 if "<space>$_service_name<space>" appears in $t
+    [ "${t#* ${_service_name} }" != "${t}" ]
 }
 
 ctdb_start_stop_service ()
 {
-    _active="$ctdb_active_dir/$service_name"
+    _service_name="${1:-${service_name}}"
 
-    if is_ctdb_managed_service ; then
+    _active="$ctdb_active_dir/$_service_name"
+    if is_ctdb_managed_service "$_service_name"; then
        if ! [ -e "$_active" ] ; then
-           echo "Starting service $service_name"
+           echo "Starting service $_service_name"
            ctdb_service_start || exit $?
            mkdir -p "$ctdb_active_dir"
            touch "$_active"
            exit 0
        fi
-    elif ! is_ctdb_managed_service ; then
+    else
        if [ -e "$_active" ] ; then
-           echo "Stopping service $service_name"
+           echo "Stopping service $_service_name"
            ctdb_service_stop || exit $?
            rm -f "$_active"
+           exit 0
        fi
-       exit 0
     fi
 }
 
 ctdb_service_start ()
 {
     if [ -n "$service_start" ] ; then
-       eval $service_start
+       eval $service_start || return $?
     else
-       service "$service_name" start
+       service "$service_name" start || return $?
     fi
     ctdb_counter_init
 }
@@ -594,12 +738,138 @@ ctdb_standard_event_handler ()
            exit
            ;;
        setstatus)
+            shift
            ctdb_setstatus "$@"
            exit
            ;;
     esac
 }
 
+ipv4_host_addr_to_net_addr()
+{
+       local HOST=$1
+       local MASKBITS=$2
+
+       local HOST0=$(echo $HOST | awk -F . '{print $4}')
+       local HOST1=$(echo $HOST | awk -F . '{print $3}')
+       local HOST2=$(echo $HOST | awk -F . '{print $2}')
+       local HOST3=$(echo $HOST | awk -F . '{print $1}')
+
+       local HOST_NUM=$(( $HOST0 + $HOST1 * 256 + $HOST2 * (256 ** 2) + $HOST3 * (256 ** 3) ))
+
+       local MASK_NUM=$(( ( (2**32 - 1) * (2**(32 - $MASKBITS)) ) & (2**32 - 1) ))
+
+       local NET_NUM=$(( $HOST_NUM & $MASK_NUM))
+
+       local NET0=$(( $NET_NUM & 255 ))
+       local NET1=$(( ($NET_NUM & (255 * 256)) / 256 ))
+       local NET2=$(( ($NET_NUM & (255 * 256**2)) / 256**2 ))
+       local NET3=$(( ($NET_NUM & (255 * 256**3)) / 256**3 ))
+
+       echo "$NET3.$NET2.$NET1.$NET0"
+}
+
+ipv4_maskbits_to_net_mask()
+{
+       local MASKBITS=$1
+
+       local MASK_NUM=$(( ( (2**32 - 1) * (2**(32 - $MASKBITS)) ) & (2**32 - 1) ))
+
+       local MASK0=$(( $MASK_NUM & 255 ))
+       local MASK1=$(( ($MASK_NUM & (255 * 256)) / 256 ))
+       local MASK2=$(( ($MASK_NUM & (255 * 256**2)) / 256**2 ))
+       local MASK3=$(( ($MASK_NUM & (255 * 256**3)) / 256**3 ))
+
+       echo "$MASK3.$MASK2.$MASK1.$MASK0"
+}
+
+ipv4_is_valid_addr()
+{
+       local ADDR=$1
+       local fail=0
+
+       local N=`echo $ADDR | sed -e 's/[0-9][0-9]*\.[0-9][0-9]*\.[0-9][0-9]*\.[0-9][0-9]*//'`
+       test -n "$N" && fail=1
+
+       local ADDR0=$(echo $ADDR | awk -F . '{print $4}')
+       local ADDR1=$(echo $ADDR | awk -F . '{print $3}')
+       local ADDR2=$(echo $ADDR | awk -F . '{print $2}')
+       local ADDR3=$(echo $ADDR | awk -F . '{print $1}')
+
+       test "$ADDR0" -gt 255 && fail=1
+       test "$ADDR1" -gt 255 && fail=1
+       test "$ADDR2" -gt 255 && fail=1
+       test "$ADDR3" -gt 255 && fail=1
+
+       test x"$fail" != x"0" && {
+               #echo "IPv4: '$ADDR' is not a valid address"
+               return 1;
+       }
+
+       return 0;
+}
+
+# iptables doesn't like being re-entered, so flock-wrap it.
+iptables()
+{
+       flock -w 30 /var/ctdb/iptables-ctdb.flock /sbin/iptables "$@"
+}
+
+########################################################
+# tickle handling
+########################################################
+
+# Temporary directory for tickles.
+tickledir="$CTDB_VARDIR/state/tickles"
+mkdir -p "$tickledir"
+
+update_tickles ()
+{
+       _port="$1"
+
+       mkdir -p "$tickledir" # Just in case
+
+       # Who am I?
+       _pnn=$(ctdb pnn) ; _pnn=${_pnn#PNN:}
+
+       # What public IPs do I hold?
+       _ips=$(ctdb -Y ip | awk -F: -v pnn=$_pnn '$3 == pnn {print $2}')
+
+       # IPs as a regexp choice
+       _ipschoice="($(echo $_ips | sed -e 's/ /|/g' -e 's/\./\\\\./g'))"
+
+       # Record connections to our public IPs in a temporary file
+       _my_connections="${tickledir}/${_port}.connections"
+       rm -f "$_my_connections"
+       netstat -tn |
+       awk -v destpat="^${_ipschoice}:${_port}\$" \
+         '$1 == "tcp" && $6 == "ESTABLISHED" && $4 ~ destpat {print $5, $4}' |
+       sort >"$_my_connections"
+
+       # Record our current tickles in a temporary file
+       _my_tickles="${tickledir}/${_port}.tickles"
+       rm -f "$_my_tickles"
+       for _i in $_ips ; do
+               ctdb -Y gettickles $_i $_port | 
+               awk -F: 'NR > 1 { printf "%s:%s %s:%s\n", $2, $3, $4, $5 }'
+       done |
+       sort >"$_my_tickles"
+
+       # Add tickles for connections that we haven't already got tickles for
+       comm -23 "$_my_connections" "$_my_tickles" |
+       while read _src _dst ; do
+               ctdb addtickle $_src $_dst
+       done
+
+       # Remove tickles for connections that are no longer there
+       comm -13 "$_my_connections" "$_my_tickles" |
+       while read _src _dst ; do
+               ctdb deltickle $_src $_dst
+       done
+
+       rm -f "$_my_connections" "$_my_tickles" 
+}
+
 ########################################################
 # load a site local config file
 ########################################################